Subject: bug#71823: 31.0.50; project-mode-line and eglot duplicate project-name in mode-line

From: Eli Zaretskii <[email-masked]>
Date: Sat, 29 Jun 2024 15:43:17 +0300

> Date: Sat, 29 Jun 2024 14:59:10 +0300
> Cc: [email-masked], [email-masked], Juri Linkov <[email-masked]>
> From: Dmitry Gutov <[email-masked]>
> 
> On 29/06/2024 10:12, Eli Zaretskii wrote:
> > After all, the project-mode-line
> > option belongs to project.el, so the fact that it adds the project
> > name to the mode line too indiscriminately can legitimately be
> > considered to be a problem with that option.  Right?
> 
> It's "discriminate"

In what way?

> and off by default.

Sure, I meant when the option is turned on.

> > On top of that,
> > project-mode-line is new in Emacs 30, whereas Eglot has been showing
> > the project in its mode line before that.  So once again, IMO the onus
> > is on project.el to fix this somehow.  For example, by not adding this
> > to the mode line in Eglot-controlled buffers.
> 
> Hard-coding an "unless Eglot" condition seems like a bad idea in terms 
> of abstraction and general code logic.

I agree, but Spencer's patch did the same in the opposite direction.

> But if you have some specific improvements to suggest, please go
> ahead.

I don't, but maybe someone else does.  AFAIU, João suggested something
like that as well.  So we all agree about the way to solve it, and we
"just" need a patch that implements such a solution.